'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      MemberExpression: function MemberExpression(path, state) {
        var node = path.node;
        var file = path.file;

        var re = new RegExp(state.opts.matchPattern, 'g');

        if (t.isCallExpression(node.object) && t.isIdentifier(node.object.callee, { name: 'require' }) && t.isLiteral(node.object.arguments[0]) && node.object.arguments[0].value.match(re)) {
          var srcPath = _path2.default.resolve(state.file.opts.filename);
          var requireText = node.object.arguments[0].value;

          var jsonPath = _path2.default.join(srcPath, '..', requireText);
          var pkg = void 0;
          if (_fs2.default.existsSync(jsonPath + '.json')) {
            pkg = require(jsonPath);
          } else {
            pkg = require(_resolve2.default.sync(requireText, {
              basedir: _path2.default.dirname(srcPath)
            }));
          }

          var value = pkg[node.property.name];
          path.replaceWith(t.expressionStatement(t.valueToNode(value)));
        }
      }
    }
  };
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _resolve = require('resolve');

var _resolve2 = _interopRequireDefault(_resolve);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }